<template>
  <div>
    <div class="icon-container" @click="downloadRenderedFile">
      <!-- <IonIcon
        :icon="arrowDownCircle"
        size="large"
        color="primary file-download-icon"
      ></IonIcon> -->
      <IonIcon
        class="file-download-icon"
        icon="/Images/tabs/messages/download-file-icon.svg"
        color="white"
        v-if="mainDownloadState == 'requestNotSent'"
      ></IonIcon>
      <IonIcon
        v-if="mainDownloadState == 'downloading'"
        class="file-download-icon"
        icon="/Images/tabs/messages/downloading-file-icon.svg"
        color="white"
      ></IonIcon>
      <IonIcon
        v-if="mainDownloadState == 'downloaded'"
        class="file-download-icon downloaded-icon"
        icon="/Images/tabs/messages/file-sheet.svg"
        color="white"
      ></IonIcon>
    </div>
    <div class="file-detaile">
      <div class="file-name ellipsis-text">
        {{ fileInfo?.name }}
      </div>
      <div class="file-size ellipsis-text">
        {{ fileInfo?.mbSize }}MB
        {{ fileInfo?.renderedType }}
      </div>
    </div>
  </div>
</template>
<script setup>
import { IonIcon } from '@ionic/vue';
import { ref, defineProps, onMounted } from 'vue';
import { useFileManagerStore } from '@/store/fileManager/fileManager.js';
import { getItemFromIndexDB } from '@/helpers/dbManager';

const props = defineProps({
  fileInfo: {
    type: Object,
    default: () => {
      return {
        id: '',
        name: '',
        mbSize: '',
        renderedType: '',
        fileId: '',
      };
    },
  },
  blobFilePath: {},
  mainDownloadState: {},
});
const mainDownloadState = ref(props.mainDownloadState);
const blobFilePath = ref(null);
const downloadRenderedFile = async () => {
  mainDownloadState.value = 'downloading';
  const fileManagerStore = useFileManagerStore();
  const file = await fileManagerStore.handlerForGettingFile(
    props.fileInfo.fileId,
    'file',
  );
  mainDownloadState.value = 'downloaded';
  const link = document.createElement('a');
  link.href = file.filePath;
  link.download = props.fileInfo.name; // Change the filename as needed
  link.click();
};
const fileDownloadStateHandler = async () => {
  const fileContent = await getItemFromIndexDB('files', props.fileInfo.fileId);
  if (fileContent) {
    blobFilePath.value = URL.createObjectURL(fileContent.mainFile);
    mainDownloadState.value = 'downloaded';
  }
};

onMounted(() => {
  fileDownloadStateHandler();
});
</script>
<style scoped>
.file-container {
  display: flex;
  gap: 5px;
}
.file-detaile,
.file-size {
  width: 40vw;
}
.icon-container {
  width: 35px;
  height: 35px;
  min-width: 35px;
  min-height: 35px;
  background-color: var(--ion-color-primary);
  border-radius: 50%;
  position: relative;
}
.file-download-icon {
  width: 102%;
  height: 102%;
}
.downloaded-icon {
  position: absolute;
  width: 80%;
  height: 80%;
  left: 10%;
  top: 10%;
}
</style>
